#!/usr/bin/perl
#
# Written by andy@technolabs.co.uk
#
# Description:
#
# Simple perl client to perform Dynamic DNS updates.
# This only returns the primary address on an interface
# If you wish to return other addresses, please modify the code that 
# parses out information from the interface.
# 
# Complete the 5 variables below in the config section.
# Add this script to cron running every 5 mins
# Cron Example: 0/5 * * * * root /opt/scripts/dyndns.pl
#
# See README for more infomation

# Config Section

$username = "andy"; 		# your supplied username
$password = "password"; 	# your supplied password
$host	  = "myhost";		# your chosen hostname	
$domain	  = "example.org";	# your chosen domain
$interface= "gem0";		# interface that has IP to be updated (fxp0, dc0, etc etc)

# End Config

## First parse out interface

$output=`ifconfig $interface | grep -w inet`;
if ($output =~ /((\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3}))/ ) 
{ 
  $ip=$1; 
}

## Build the request aand submit

use LWP::UserAgent;

$ua = new LWP::UserAgent;
$ua->agent("Technolabs " . $ua->agent);

my $post = "username=$username&password=$password&hostname=$host&domain=$domain&ip_address=$ip";

# Create a request
my $req = new HTTP::Request POST => 'https://www.technolabs.co.uk/dyndns.php';
$req->content_type('application/x-www-form-urlencoded');
$req->content($post);

# Pass request to the user agent and get a response back
my $res = $ua->request($req);


# check the outcome
if ($res->is_success) 
{
  $out = $res->decoded_content;
  if($out =~ /Update Success/ )
  {
    print ("Update Success: IP set to $ip!!\n");
  }
  elsif ($out =~ /Update Failed/ )
  {
    print ("Update Failed: Please check your configuration!!\n");
  }
  elsif ($out =~ /IP Match/ )
  {
    print("IP Match: No Need to update!\n");
  }
}
else 
{
  print "Error: " . $res->status_line . "\n";
}
