#!/usr/bin/perl
#
# written by andy@technolabs.co.uk
#
# cron script to parse dyndns updates from mysql db
# and apply them to the various zone files
#
# See README for more infomation
#

use DBI;
use DNS::ZoneParse;
use Sys::Syslog qw( :DEFAULT setlogsock);

# set this to point to the directory containing zone files
# Note all zone files end with .zone
my $path = "/etc/namedb/master";

# set this to your DB config
my $dbhost   =  "localhost";
my $db       =  "myDB";
my $user     =  "myDBuser";
my $password =  "myDBpassword";

# get updates from db
my $db = DBI->connect("DBI:mysql:database=$db;host=$dbhost",$user, $password);
my $query = "SELECT hostname, domain, ip_address from dyndns where changed=True";
my $info = $db->prepare($query);
$info->execute;

# process any updates 
while (my ($hostname, $domain, $ip_address) = $info->fetchrow_array()) 
{
   my $zonefile = DNS::ZoneParse->new("$path/$domain.zone", $origin);
   my $a_records = $zonefile->a();
   foreach my $record (@$a_records) 
   {
     if("$record->{name}" eq "$hostname")
     {
       $record->{host} = $ip_address;
       $user = $ENV{'USER'};
       setlogsock('unix');
       openlog($0,'','user');
       syslog(warning, "DYNDNS: Updated records for $hostname.$domain: IP set to $ip_address");
       print "$hostname.$domain = $ip_address\n";
     
       # update the serial number
       $zonefile->new_serial();

       # write the new zone file to disk
       open NEWZONE, ">$path/$domain.zone.new" or die "error";
       print NEWZONE $zonefile->output();
       close NEWZONE;

       # finally copy updated zone file into place and send update via rndc
       $oldpath="$path/$domain.zone.new";
       $newpath="$path/$domain.zone";
       rename($oldpath, $newpath);
       system("/usr/sbin/rndc reload $domain");
       my $query = "UPDATE dyndns set changed=False where domain = '$domain'";
       my $info = $db->prepare($query);
       $info->execute;
     }
   }
}
$info->finish();
exit;

